/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.71 by edhill, Wed Mar 10 23:34:04 2004 UTC revision 1.89 by edhill, Wed Jul 21 16:34:46 2004 UTC
# Line 67  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -f Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    %.$tfs : %.F
128    .SUFFIXES:
129    genmake_hello.$tfs: genmake_hello.F
130            $LN genmake_hello.F genmake_hello.$tfs
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -f Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161    look_for_makedepend()  {
162    
163        #  The "original" makedepend is part of the Imake system that is
164        #  most often distributed with XFree86 or with an XFree86 source
165        #  package.  As a result, many machines (eg. generic Linux) do not
166        #  have a system-default "makedepend" available.  For those
167        #  systems, we have two fall-back options:
168        #
169        #    1) a makedepend implementation shipped with the cyrus-imapd
170        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
171        #
172        #    2) a known-buggy xmakedpend shell script
173        #
174        #  So the choices are, in order:
175        #
176        #    1) use the user-specified program
177        #    2) use a system-wide default
178        #    3) locally build and use the cyrus implementation
179        #    4) fall back to the buggy local xmakedpend script
180        #
181        if test "x${MAKEDEPEND}" = x ; then
182            which makedepend > /dev/null 2>&1
183            RV0=$?
184            cat <<EOF >> genmake_tc.f
185          program test
186          write(*,*) 'test'
187          stop
188          end
189    EOF
190            makedepend genmake_tc.f > /dev/null 2>&1
191            RV1=$?
192            if test "x${RV0}${RV1}" = x00 ; then
193                MAKEDEPEND=makedepend
194            else
195                echo "    a system-default makedepend was not found."
196                
197                #  Try to build the cyrus implementation
198                rm -f ./genmake_cy_md
199                (
200                    cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
201                        &&  ./configure > /dev/null 2>&1  \
202                        &&  make > /dev/null 2>&1
203                    if test -x ./makedepend.exe ; then
204                        $LN ./makedepend.exe ./makedepend
205                    fi
206                    ./makedepend ifparser.c > /dev/null 2>&1  \
207                        &&  echo "true"
208                ) > ./genmake_cy_md
209                grep true ./genmake_cy_md > /dev/null 2>&1
210                RETVAL=$?
211                if test "x$RETVAL" = x0 ; then
212                    MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
213                else
214                    MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
215                fi
216                rm -f ./genmake_cy_md
217            fi
218        fi
219    }
220    
221    
222  # Guess possible config options for this host  # Guess possible config options for this host
223  find_possible_configs()  {  find_possible_configs()  {
224    
# Line 80  find_possible_configs()  { Line 227  find_possible_configs()  {
227      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
228      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
229      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
230      PLATFORM=$tmp2      tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
231        PLATFORM=$tmp3
232        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
233      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
234      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
235            
# Line 100  find_possible_configs()  { Line 249  find_possible_configs()  {
249          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
250      fi      fi
251    
252      #  The "original" makedepend is part of the Imake system that is      look_for_makedepend
     #  most often distributed with XFree86 or with an XFree86 source  
     #  package.  As a result, many machines (eg. generic Linux) do not  
     #  have a system-default "makedepend" available.  For those  
     #  systems, we have two fall-back options:  
     #  
     #    1) a makedepend implementation shipped with the cyrus-imapd  
     #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/  
     #  
     #    2) a known-buggy xmakedpend shell script  
     #  
     #  So the choices are, in order:  
     #  
     #    1) use the user-specified program  
     #    2) use a system-wide default  
     #    3) locally build and use the cyrus implementation  
     #    4) fall back to the buggy local xmakedpend script  
     #  
     if test "x${MAKEDEPEND}" = x ; then  
       which makedepend >& /dev/null  
       RETVAL=$?  
       if test ! "x${RETVAL}" = x0 ; then  
          echo "    a system-default makedepend was not found."  
   
          #  Try to build the cyrus impl  
          rm -f ./genmake_cy_md  
          (  
              cd $ROOTDIR/tools/cyrus-imapd-makedepend  \  
                  &&  ./configure > /dev/null 2>&1  \  
                  &&  make > /dev/null 2>&1  \  
                  &&  ./makedepend ifparser.c > /dev/null 2>&1  \  
                  &&  echo "true"  
          ) > ./genmake_cy_md  
          grep true ./genmake_cy_md > /dev/null 2>&1  
          RETVAL=$?  
          if test "x$RETVAL" = x0 ; then  
              MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'  
          else  
              MAKEDEPEND='$(TOOLSDIR)/xmakedepend'  
          fi  
          rm -f ./genmake_cy_md  
       fi  
     fi  
253    
254      # look for possible fortran compilers      # look for possible fortran compilers
255      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
# Line 272  Usage: "$0" [OPTIONS] Line 379  Usage: "$0" [OPTIONS]
379      -help | --help | -h | --h      -help | --help | -h | --h
380            Print this help message and exit.            Print this help message and exit.
381    
382        -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
383          -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
384              Use "NAME" as the adoptfile.  By default, the file at
385              "tools/adjoint_options/adjoint_default" will be used.
386    
387      -nooptfile | --nooptfile      -nooptfile | --nooptfile
388        -optfile NAME | --optfile NAME | -of NAME | --of NAME        -optfile NAME | --optfile NAME | -of NAME | --of NAME
389        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
# Line 371  EOF Line 483  EOF
483    
484  #  Build a CPP macro to automate calling C routines from FORTRAN  #  Build a CPP macro to automate calling C routines from FORTRAN
485  get_fortran_c_namemangling()  {  get_fortran_c_namemangling()  {
486    
487        #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
488        if test ! "x$FC_NAMEMANGLE" = x ; then
489            return 0
490        fi
491    
492      default_nm="#define FC_NAMEMANGLE(X) X ## _"      default_nm="#define FC_NAMEMANGLE(X) X ## _"
493            
494      cat > genmake_test.c <<EOF      cat > genmake_test.c <<EOF
# Line 495  EOF Line 613  EOF
613    
614    
615  check_netcdf_libs()  {  check_netcdf_libs()  {
616      cat <<EOF > genmake_tnc.F      cat <<EOF > genmake_tnc.for
617        program fgennc        program fgennc
618  #include "netcdf.inc"  #include "netcdf.inc"
619        integer iret, ncid, xid        integer iret, ncid, xid
# Line 507  check_netcdf_libs()  { Line 625  check_netcdf_libs()  {
625        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
626        end        end
627  EOF  EOF
628      $CPP genmake_tnc.F > genmake_tnc.f  \      #echo "$CPP $DEFINES $INCLUDES"
629        $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f  \
630          &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1          &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
631      RET_COMPILE=$?      RET_COMPILE=$?
632      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
# Line 516  EOF Line 635  EOF
635          HAVE_NETCDF=t          HAVE_NETCDF=t
636      else      else
637          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
638          $CPP genmake_tnc.F > genmake_tnc.f  \          $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f  \
639              &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \              &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
640              $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1              $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
641          RET_COMPILE=$?          RET_COMPILE=$?
# Line 578  HAVE_FDATE= Line 697  HAVE_FDATE=
697  FC_NAMEMANGLE=  FC_NAMEMANGLE=
698  HAVE_CLOC=  HAVE_CLOC=
699  HAVE_NETCDF=  HAVE_NETCDF=
700    HAVE_ETIME=
701    
702  MODS=  MODS=
703  TOOLSDIR=  TOOLSDIR=
# Line 585  SOURCEDIRS= Line 705  SOURCEDIRS=
705  INCLUDEDIRS=  INCLUDEDIRS=
706  STANDARDDIRS="USE_THE_DEFAULT"  STANDARDDIRS="USE_THE_DEFAULT"
707    
708    G2ARGS=
709  BASH=  BASH=
710  PWD=`pwd`  PWD=`pwd`
711  MAKE=make  MAKE=make
# Line 601  IEEE= Line 722  IEEE=
722  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
723      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
724  fi  fi
725    FS=
726    FS90=
727    
728  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
729  AD_OPTFILE=  AD_OPTFILE=
# Line 625  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPE Line 748  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPE
748  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
749  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
750  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
751  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
752    
753  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
754  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
# Line 655  for i in . $MODS ; do Line 778  for i in . $MODS ; do
778      fi      fi
779  done  done
780  printf "  getting local config information:  "  printf "  getting local config information:  "
781  if test -e $gm_local ; then  if test -f $gm_local ; then
782      echo "using $gm_local"      echo "using $gm_local"
783      . $gm_local      . $gm_local
784      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
# Line 676  fi Line 799  fi
799  #done  #done
800  #parse_options  #parse_options
801  ac_prev=  ac_prev=
802  for ac_option ; do  for ac_option in $@ ; do
803    
804        G2ARGS="$G2ARGS \"$ac_option\""
805    
806      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
807      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
# Line 776  for ac_option ; do Line 901  for ac_option ; do
901          -fc=* | --fc=*)          -fc=* | --fc=*)
902              FC=$ac_optarg ;;              FC=$ac_optarg ;;
903                    
904            -fs | --fs)
905                ac_prev=FS ;;
906            -fs=* | --fs=*)
907                FS=$ac_optarg ;;
908            
909            -fs90 | --fs90)
910                ac_prev=FS90 ;;
911            -fs90=* | --fs90=*)
912                FS90=$ac_optarg ;;
913            
914          -ieee | --ieee)          -ieee | --ieee)
915              IEEE=true ;;              IEEE=true ;;
916          -noieee | --noieee)          -noieee | --noieee)
# Line 832  if test -f ./.genmakerc ; then Line 967  if test -f ./.genmakerc ; then
967  fi  fi
968    
969  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
970      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
971        if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
972          ROOTDIR=".."          ROOTDIR=".."
973      else      else
974          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
# Line 885  if test "x$OPTFILE" != xNONE ; then Line 1021  if test "x$OPTFILE" != xNONE ; then
1021      fi      fi
1022  fi  fi
1023    
1024    #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1025    # check_for_broken_Ff
1026    
1027  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1028  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1029      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 938  if test "x$CPP" = x ; then Line 1077  if test "x$CPP" = x ; then
1077      CPP=cpp      CPP=cpp
1078  fi  fi
1079  #EH3 === UGLY ===  #EH3 === UGLY ===
1080  #  The following an ugly little hack to check for $CPP in /lib/ and it  #  The following is an ugly little hack to check for $CPP in /lib/ and
1081  #  should eventually be replaced with a more general function that  #  it should eventually be replaced with a more general function that
1082  #  searches a combo of the user's path and a list of "usual suspects"  #  searches a combo of the user's path and a list of "usual suspects"
1083  #  to find the correct location for binaries such as $CPP.  #  to find the correct location for binaries such as $CPP.
1084  for i in " " "/lib/" ; do  for i in " " "/lib/" ; do
# Line 962  EOF Line 1101  EOF
1101  else  else
1102      rm -f test_cpp      rm -f test_cpp
1103  fi  fi
1104  if test "x$MAKEDEPEND" = x ; then  look_for_makedepend
     MAKEDEPEND=makedepend  
 fi  
1105  if test "x$LN" = x ; then  if test "x$LN" = x ; then
1106      LN="ln -s"      LN="ln -s"
1107  fi  fi
# Line 982  EOF Line 1119  EOF
1119  fi  fi
1120  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1121    
1122    #  Check for broken *.F/*.f handling and fix if possible
1123    check_for_broken_Ff
1124    
1125  if test ! "x$MPI" = x ; then  if test ! "x$MPI" = x ; then
1126        echo "  Turning on MPI cpp macros"        echo "  Turning on MPI cpp macros"
1127        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
# Line 1027  else Line 1167  else
1167  fi  fi
1168  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1169    
1170    printf "  Do we have the etime() command using $FC...  "
1171    cat > genmake_tcomp.f <<EOF
1172          program hello
1173          REAL*4 ACTUAL, TARRAY(2)
1174          EXTERNAL ETIME
1175          REAL*4 ETIME
1176          actual = etime( tarray )
1177          print *, tarray
1178          end
1179    EOF
1180    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1181    RETVAL=$?
1182    if test "x$RETVAL" = x0 ; then
1183        HAVE_ETIME=t
1184        DEFINES="$DEFINES -DHAVE_ETIME"
1185        echo "yes"
1186    else
1187        HAVE_ETIME=
1188        echo "no"
1189    fi
1190    rm -f genmake_tcomp*
1191    
1192  printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "  printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1193  check_HAVE_CLOC  check_HAVE_CLOC
1194  if test "x$HAVE_CLOC" != x ; then  if test "x$HAVE_CLOC" != x ; then
# Line 1068  if test "x${PLATFORM}" = x ; then Line 1230  if test "x${PLATFORM}" = x ; then
1230  fi  fi
1231    
1232  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1233      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
1234        if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1235          EXEDIR=../exe          EXEDIR=../exe
1236      else      else
1237          EXEDIR=.          EXEDIR=.
# Line 1186  else Line 1349  else
1349              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1350          done          done
1351          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1352          expand_pkg_groups          RET=1
1353            while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1354          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1355      fi      fi
1356  fi  fi
1357    
1358  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1359    for i in $PACKAGES ; do
1360        echo $i >> ./.tmp_pack
1361    done
1362    for i in `grep  "-" ./.tmp_pack` ; do
1363        j=`echo $i | sed 's/[-]//'`
1364        DISABLE="$DISABLE $j"
1365    done
1366  pack=  pack=
1367  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1368      addit="t"      addit="t"
# Line 1208  PACKAGES="$pack" Line 1379  PACKAGES="$pack"
1379  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1380  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1381  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1382    # Test if each explicitly referenced package exists
1383  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1384      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1385        if test ! -d "$ROOTDIR/pkg/$j" ; then
1386          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1387          exit 1          exit 1
1388      fi      fi
1389      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1390  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1391  PACKAGES=  PACKAGES=
1392  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1393      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1394  done  done
1395    rm -f ./.tmp_pack
1396  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1397    
1398  echo "  applying package dependency rules"  echo "  applying package dependency rules"
# Line 1287  while test "x$ck" != xtt ; do Line 1459  while test "x$ck" != xtt ; do
1459              echo "  the dependency rules for \"$dname\""              echo "  the dependency rules for \"$dname\""
1460              exit 1              exit 1
1461          fi          fi
1462          i=$(( $i + 1 ))          i=`echo "$i + 1" | bc -l`
1463            #i=$(( $i + 1 ))
1464      done      done
1465      ck=$ck"t"      ck=$ck"t"
1466  done  done
# Line 1449  echo Line 1622  echo
1622  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1623  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1624  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1625      if ! test -d $i ; then      if test ! -d $i ; then
 #       INCLUDES="$INCLUDES -I$i"  
 #   else  
1626          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1627      fi      fi
1628  done  done
# Line 1526  echo "" >> f90srclist.inc Line 1697  echo "" >> f90srclist.inc
1697  echo "" >> hlist.inc  echo "" >> hlist.inc
1698  echo "" >> ad_flow_files.inc  echo "" >> ad_flow_files.inc
1699    
1700  if test -e $MAKEFILE ; then  if test -f $MAKEFILE ; then
1701      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
1702  fi  fi
1703  echo "  Writing makefile: $MAKEFILE"  echo "  Writing makefile: $MAKEFILE"
# Line 1535  echo "#    $MACHINE" >> $MAKEFILE Line 1706  echo "#    $MACHINE" >> $MAKEFILE
1706  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1707  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1708  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1709  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1710  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1711  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1712    
# Line 1635  cat csrclist.inc      >> $MAKEFILE Line 1806  cat csrclist.inc      >> $MAKEFILE
1806  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1807  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1808  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
1809  echo               >> $MAKEFILE  echo >> $MAKEFILE
1810  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
1811  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
1812  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1813    echo >> $MAKEFILE
1814    echo '.SUFFIXES:' >> $MAKEFILE
1815    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
1816  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1817  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
1818    
1819  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1820    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
1821  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1822  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1823          @echo Creating \$@ ...          @echo Creating \$@ ...
1824          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1825  depend:  depend:
1826          @make links          @make links
1827          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1828          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1829            -rm -f makedepend.out
1830    
1831  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1832    
# Line 1666  output.txt: \$(EXECUTABLE) Line 1837  output.txt: \$(EXECUTABLE)
1837          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1838    
1839  clean:  clean:
1840          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
1841  Clean:  Clean:
1842          @make clean          @make clean
1843          @make cleanlinks          @make cleanlinks
# Line 1677  CLEAN: Line 1848  CLEAN:
1848          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1849          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1850          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1851          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
1852    
1853  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1854  makefile:  makefile:
1855          $THIS_SCRIPT $@          $THIS_SCRIPT $G2ARGS
1856  cleanlinks:  cleanlinks:
1857          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1858    
# Line 1696  FC_NAMEMANGLE.h: Line 1867  FC_NAMEMANGLE.h:
1867          @echo Creating \$@ ...          @echo Creating \$@ ...
1868          echo "$FC_NAMEMANGLE" > \$@          echo "$FC_NAMEMANGLE" > \$@
1869    
1870  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
1871  .F.f:  
1872    %.o : %.F
1873    
1874    .F.$FS:
1875          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1876  .f.o:  .$FS.o:
1877          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1878  .F90.f90:  .F90.$FS90:
1879          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1880  .f90.o:  .$FS90.o:
1881          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
1882  .c.o:  .c.o:
1883          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
1884    
1885  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
1886  .F.p:  .F.p:
1887          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1888  .p.f:  .p.$FS:
1889          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1890    
1891  #=========================================  #=========================================
# Line 1836  for i in $KPPFILES ; do Line 2010  for i in $KPPFILES ; do
2010      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2011          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2012      fi      fi
2013      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
2014  done  done
2015    
2016  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1846  for i in $NOOPTFILES ; do Line 2020  for i in $NOOPTFILES ; do
2020      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2021          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2022      fi      fi
2023      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2024      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2025  done  done
2026    

Legend:
Removed from v.1.71  
changed lines
  Added in v.1.89

  ViewVC Help
Powered by ViewVC 1.1.22